"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkA11y = exports.configureAxe = exports.injectAxe = void 0;
const fs = __importStar(require("fs"));
const assert_1 = __importDefault(require("assert"));
exports.injectAxe = (page) => __awaiter(void 0, void 0, void 0, function* () {
    const axe = fs.readFileSync('node_modules/axe-core/axe.min.js', 'utf8');
    yield page.evaluate((axe) => window.eval(axe), axe);
});
exports.configureAxe = (page, configurationOptions = {}) => __awaiter(void 0, void 0, void 0, function* () {
    yield page.evaluate((configOptions) => window.axe.configure(configOptions), configurationOptions);
});
exports.checkA11y = (page, context = undefined, options = undefined, skipFailures = false) => __awaiter(void 0, void 0, void 0, function* () {
    let axeResults = yield page.evaluate(([context, options]) => {
        const axeOptions = options ? options['axeOptions'] : {};
        return window.axe.run(context || window.document, axeOptions);
    }, [context, options]);
    const { includedImpacts, detailedReport = false, detailedReportOptions = { html: false }, } = options || {};
    const violations = getImpactedViolations(axeResults.violations, includedImpacts);
    printViolationTerminal(violations, detailedReport, !!detailedReportOptions.html);
    testResultDependsOnViolations(violations, skipFailures);
});
const getImpactedViolations = (violations, includedImpacts = []) => {
    return Array.isArray(includedImpacts) && includedImpacts.length
        ? violations.filter((v) => v.impact && includedImpacts.includes(v.impact))
        : violations;
};
const testResultDependsOnViolations = (violations, skipFailures) => {
    if (!skipFailures) {
        assert_1.default.strictEqual(violations.length, 0, `${violations.length} accessibility violation${violations.length === 1 ? '' : 's'} ${violations.length === 1 ? 'was' : 'were'} detected`);
    }
    else {
        if (violations.length) {
            console.log({
                name: 'a11y violation summary',
                message: `${violations.length} accessibility violation${violations.length === 1 ? '' : 's'} ${violations.length === 1 ? 'was' : 'were'} detected`,
            });
        }
    }
};
const describeViolations = (violations) => {
    const aggregate = {};
    violations.map(({ nodes }, index) => {
        nodes.forEach(({ target, html }) => {
            const key = JSON.stringify(target) + html;
            if (aggregate[key]) {
                aggregate[key].violations.push(index);
            }
            else {
                aggregate[key] = {
                    target: JSON.stringify(target),
                    html,
                    violations: [index],
                };
            }
        });
    });
    return Object.values(aggregate).map(({ target, html, violations }) => {
        return { target, html, violations: JSON.stringify(violations) };
    });
};
const printViolationTerminal = (violations, detailedReport, includeHtml) => {
    const violationData = violations.map(({ id, impact, description, nodes }) => {
        return {
            id,
            impact,
            description,
            nodes: nodes.length,
        };
    });
    if (violationData.length > 0) {
        // summary
        console.table(violationData);
        if (detailedReport) {
            const nodeViolations = describeViolations(violations).map(({ target, html, violations }) => {
                if (!includeHtml) {
                    return {
                        target,
                        violations,
                    };
                }
                return { target, html, violations };
            });
            // per node
            console.table(nodeViolations);
        }
    }
};
